Index: squid/src/access_log.c
diff -u squid/src/access_log.c:1.17 squid/src/access_log.c:1.15.2.2
--- squid/src/access_log.c:1.17	Sun Jun 16 10:48:14 2002
+++ squid/src/access_log.c	Tue Sep  3 10:41:34 2002
@@ -64,6 +64,7 @@
     "TCP_MEM_HIT",
     "TCP_DENIED",
     "TCP_OFFLINE_HIT",
+    "TCP_PUT",
 #if LOG_TCP_REDIRECTS
     "TCP_REDIRECT",
 #endif
@@ -72,6 +73,7 @@
     "UDP_DENIED",
     "UDP_INVALID",
     "UDP_MISS_NOFETCH",
+    "UDP_PUT",
     "ICP_QUERY",
     "LOG_TYPE_MAX"
 };
Index: squid/src/acl.c
diff -u squid/src/acl.c:1.55 squid/src/acl.c:1.42.2.3
--- squid/src/acl.c:1.55	Sun Sep  1 09:30:41 2002
+++ squid/src/acl.c	Tue Sep  3 10:41:35 2002
@@ -363,7 +363,7 @@
     protocol_t protocol;
     for (Tail = curlist; *Tail; Tail = &((*Tail)->next));
     while ((t = strtokFile())) {
-	protocol = urlParseProtocol(t);
+	protocol = urlParseProtocol(t, 0, 0);
 	q = memAllocate(MEM_INTLIST);
 	q->i = (int) protocol;
 	*(Tail) = q;
Index: squid/src/cache_cf.c
diff -u squid/src/cache_cf.c:1.47 squid/src/cache_cf.c:1.38.2.4
--- squid/src/cache_cf.c:1.47	Sun Sep  1 09:30:41 2002
+++ squid/src/cache_cf.c	Tue Sep  3 10:41:37 2002
@@ -1535,6 +1535,21 @@
 	    p->options.allow_miss = 1;
 	} else if (!strncasecmp(token, "max-conn=", 9)) {
 	    p->max_conn = xatoi(token + 9);
+	} else if (!strncasecmp(token, "dist", 4)) {
+	    p->options.dist = 1;
+	} else if (!strncasecmp(token, "fwdpush", 7)) {
+	    p->fwdpush = DistAllPeers;
+	    DistAllPeers = p;
+#if USE_ICP_DATA
+	} else if (!strncasecmp(token, "icpdata", 7)) {
+	    p->options.icpdata = 1;
+	} else if (!strncasecmp(token, "maxrate=", 8)) {
+	    p->maxrate = atoi(token + 8);
+#endif
+#if USE_HINT_CACHE
+	} else if (!strncasecmp(token, "nohint", 6)) {
+	    p->options.nohint = 1;
+#endif
 	} else {
 	    debug(3, 0) ("parse_peer: token='%s'\n", token);
 	    self_destruct();
Index: squid/src/cbdata.c
diff -u squid/src/cbdata.c:1.15 squid/src/cbdata.c:1.14.2.2
--- squid/src/cbdata.c:1.15	Sat Apr 13 16:09:15 2002
+++ squid/src/cbdata.c	Tue Sep  3 10:41:39 2002
@@ -136,6 +136,7 @@
     CREATE_CBDATA_FREE(peer, peerDestroy);
     CREATE_CBDATA(ps_state);
     CREATE_CBDATA(RemovalPolicy);
+    CREATE_CBDATA(Pusher);
     CREATE_CBDATA(RemovalPolicyWalker);
     CREATE_CBDATA(RemovalPurgeWalker);
     CREATE_CBDATA(store_client);
Index: squid/src/cf.data.pre
diff -u squid/src/cf.data.pre:1.79 squid/src/cf.data.pre:1.43.2.4
--- squid/src/cf.data.pre:1.79	Sun Sep  1 09:30:41 2002
+++ squid/src/cf.data.pre	Tue Sep  3 10:41:39 2002
@@ -279,6 +279,8 @@
 		     digest-url=url
 		     allow-miss
 		     max-conn
+ 		     dist
+ 		     nohint
 
 		     use 'proxy-only' to specify that objects fetched
 		     from this cache should not be saved locally.
@@ -385,6 +387,19 @@
 		     use 'max-conn' to limit the amount of connections Squid
 		     may open to this peer.
 
+		     'dist' tells squid to ask for consistency updates 
+                     via httpdist on all queries to that peer.
+
+		     'nohint' tells squid not to send hint cache updates
+                     to that peer.  The default is that updates are sent
+		     if hints are active.
+
+		     'icpdata' says to send pushes to this peer by the 
+		     UDP-based ICPDATA protocol instead of TCP.
+
+		     'maxrate=n' specifies the maximum rate to send
+		     ICPDATA data at.
+
 	NOTE: non-ICP neighbors must be specified as 'parent'.
 DOC_END
 
@@ -1405,6 +1420,11 @@
 	(off - for use when useragents generate nonce counts that
 	occasionally miss 1 (ie, 1,2,4,6)).
 
+	"nonce_strictness" on|off
+	Determines if squid requires increment-by-1 behaviour for nonce counts 
+	(on - the default), or strictly incrementing (off - for use when useragents
+	generate nonce counts that occasionally miss 1 (ie, 1,2,4,6)).
+
 	=== NTLM scheme options follow ===
 
 	"program" cmdline
@@ -3774,6 +3794,111 @@
 	time.  By default it is set to 10% of the Cache Digest.
 DOC_END
 
+NAME: hint_cache_listen
+IFDEF: USE_HINT_CACHE
+TYPE: onoff
+LOC: Config.onoff.hint_cache_listen
+DEFAULT: off
+DOC_START
+	This controls whether hint cache is used to decide where to 
+	forward misses.  Hint caches exchange data to track nearest
+	location and metadata of all URLs in a  hint cache cloud;
+	This variable also decides whether we listen to hints from
+	neighboring hint caches.
+DOC_END
+
+NAME: hint_cache_advertise
+IFDEF: USE_HINT_CACHE
+TYPE: onoff
+LOC: Config.onoff.hint_cache_advertise
+DEFAULT: off
+DOC_START
+	This controls whether we tell other caches about content in
+	our own cache.  We only want to do that if we are in a
+	position to efficiently serve requests from other caches.
+	
+	We encourage you to turn this on, as participation in the
+	hint cloud as a full neighbor brings greater value to
+	everybody, including yourself.
+DOC_END
+
+NAME: hint_cache_file
+IFDEF: USE_HINT_CACHE
+TYPE: string
+LOC: Config.Hints.cache_file
+DEFAULT: @DEFAULT_HINT_FILE@
+DOC_START
+	This is the name of the file holding the hint cache.  
+DOC_END
+
+NAME: hint_cache_size
+COMMENT: bytes
+IFDEF: USE_HINT_CACHE
+TYPE: int
+LOC: Config.Hints.size
+DEFAULT: 83886080
+DOC_START
+	This is the size of the hint cache, in bytes.  It has to be
+	big enough to hold location and metadata for all objects
+	tracked.
+DOC_END
+
+NAME: hint_cache_assoc
+IFDEF: USE_HINT_CACHE
+TYPE: int
+LOC: Config.Hints.assoc
+DEFAULT: 4
+DOC_START
+	Hint cache associativity.
+DOC_END
+
+NAME: hint_cache_interval
+IFDEF: USE_HINT_CACHE
+TYPE: int
+LOC: Config.Hints.intvl
+DEFAULT: 60
+DOC_START
+	Max interval between hint transmissions to neighbors, in
+	seconds.  Actual interval is randomly, uniformly distributed
+	between 0 and hint_cache_interval.
+DOC_END
+
+NAME: hint_cache_use_mmap
+IFDEF: USE_HINT_CACHE
+TYPE: onoff
+LOC: Config.onoff.hint_cache_use_mmap
+DEFAULT: off
+DOC_START
+	This tells the hint cache to access the hint cache file
+	using mmap() instead of standard file I/O.  A slight
+	speedup on machines with plenty of RAM.  If you are not
+	so long on RAM for your cache, leave it off.  It probably
+	isn't efficient unless you can hold almost the entire
+	cache in memory.  See hint_cache_size, above, for how
+	big your hint cache is.
+DOC_END
+
+NAME: hint_cache_join_interval
+IFDEF: USE_HINT_CACHE
+TYPE: int
+LOC: Config.Hints.join_intvl
+DEFAULT: 14400
+DOC_START
+	Max interval between join transmissions to neighbors, in
+	seconds.  Actual interval is randomly, uniformly distributed
+	between 0 and hint_cache_join_interval.  
+DOC_END
+
+NAME: hint_cache_holddown
+IFDEF: USE_HINT_CACHE
+TYPE: int
+LOC: Config.Hints.holddown
+DEFAULT: 900
+DOC_START
+	Amount of time to pass before we can assume that a hint
+	has finished propagating.
+DOC_END
+
 NAME: chroot
 TYPE: string
 LOC: Config.chroot_dir
Index: squid/src/client_side.c
diff -u squid/src/client_side.c:1.71 squid/src/client_side.c:1.45.2.5
--- squid/src/client_side.c:1.71	Sun Sep  1 09:30:42 2002
+++ squid/src/client_side.c	Tue Sep  3 10:41:41 2002
@@ -1986,6 +1986,9 @@
 	}
 	/* yes, continue */
 	http->log_type = LOG_TCP_MISS;
+    } else if (r->method == METHOD_PUT) {
+	putRecv(http);
+	return;
     } else {
 	http->log_type = clientProcessRequest2(http);
     }
@@ -2007,6 +2010,15 @@
 	    http->entry->mem_obj->method = r->method;
 	}
 	http->sc = storeClientListAdd(http->entry, http);
+	if (r->dist_type != DIST_NONE) {
+	    if (r->dist_type == DIST_DIST)
+		distNewUpdatee(http->entry, r->client_addr, r->dist_port);
+	    else {
+		/* DIST_UNDIST */
+		assert(r->dist_type == DIST_UNDIST);
+		distDelUpdatee(http->entry, r->client_addr, r->dist_port);
+	    }
+	}
 #if DELAY_POOLS
 	delaySetStoreClient(http->sc, delayClient(http));
 #endif
@@ -2252,7 +2264,8 @@
     *(*prefix_p + prefix_sz) = '\0';
     dlinkAdd(http, &http->active, &ClientActiveRequests);
 
-    debug(33, 5) ("parseHttpRequest: Request Header is\n%s\n", (*prefix_p) + *req_line_sz_p);
+    debug(33, 5) ("parseHttpRequest: Request Header is\n%s\n",
+		  http->hdr_str + *req_line_sz_p);
 #if THIS_VIOLATES_HTTP_SPECS_ON_URL_TRANSFORMATION
     if ((t = strchr(url, '#')))	/* remove HTML anchors */
 	*t = '\0';
@@ -2546,13 +2559,11 @@
 	if (nrequests == 0)
 	    fd_note(conn->fd, "Reading next request");
 	/* Process request */
-	http = parseHttpRequest(conn,
-	    &method,
-	    &parser_return_code,
-	    &prefix,
-	    &req_line_sz);
-	if (!http)
-	    safe_free(prefix);
+        http = parseHttpRequest(conn,
+            &method,
+            &parser_return_code,
+            &prefix,
+            &req_line_sz);
 	if (http) {
 	    assert(http->req_sz > 0);
 	    conn->in.offset -= http->req_sz;
@@ -2575,7 +2586,6 @@
 		err->request_hdrs = xstrdup(conn->in.buf);
 		http->entry = clientCreateStoreEntry(http, method, null_request_flags);
 		errorAppendEntry(http->entry, err);
-		safe_free(prefix);
 		break;
 	    }
 	    if ((request = urlParse(method, http->uri)) == NULL) {
@@ -2586,14 +2596,13 @@
 		http->al.http.code = err->http_status;
 		http->entry = clientCreateStoreEntry(http, method, null_request_flags);
 		errorAppendEntry(http->entry, err);
-		safe_free(prefix);
 		break;
 	    } else {
 		/* compile headers */
 		/* we should skip request line! */
-		if (!httpRequestParseHeader(request, prefix + req_line_sz))
+		if (!httpRequestParseHeader(request, http->hdr_str + req_line_sz))
 		    debug(33, 1) ("Failed to parse request headers: %s\n%s\n",
-			http->uri, prefix);
+			http->uri, http->hdr_str);
 		/* continue anyway? */
 	    }
 	    request->flags.accelerated = http->flags.accel;
@@ -2615,7 +2624,6 @@
 	    request->content_length = httpHeaderGetInt(&request->header,
 		HDR_CONTENT_LENGTH);
 	    request->flags.internal = http->flags.internal;
-	    safe_free(prefix);
 	    safe_free(http->log_uri);
 	    http->log_uri = xstrdup(urlCanonicalClean(request));
 	    request->client_addr = conn->peer.sin_addr;
Index: squid/src/comm.c
diff -u squid/src/comm.c:1.24 squid/src/comm.c:1.18.2.4
--- squid/src/comm.c:1.24	Thu Apr 18 23:30:40 2002
+++ squid/src/comm.c	Tue Sep  3 10:41:42 2002
@@ -631,6 +631,9 @@
 comm_close(int fd)
 {
     fde *F = NULL;
+#if USE_ICP_DATA
+   int isvfd;
+#endif     
 
     debug(5, 5) ("comm_close: FD %d\n", fd);
     assert(fd >= 0);
@@ -648,6 +651,9 @@
     if (F->ssl)
 	ssl_shutdown_method(fd);
 #endif
+#if USE_ICP_DATA
+    isvfd = (conn->comm_type == SOCK_VIRTUAL);
+#endif
     commSetTimeout(fd, -1, NULL, NULL);
     CommWriteStateCallbackAndFree(fd, COMM_ERR_CLOSING);
     commCallCloseHandlers(fd);
@@ -660,7 +666,18 @@
     }
 #endif
     fd_close(fd);		/* update fdstat */
+#if USE_ICP_DATA
+    if (isvfd) {
+	/* flag for later reuse */
+	conn->comm_type = SOCK_VIRTUAL;
+    }
+    else {
+	debug(5, 9) ("comm_close: really closing fd %d \n", fd);
+	close(fd);
+    }
+#else /* USE_ICP_DATA */
     close(fd);
+#endif /* USE_ICP_DATA */
     statCounter.syscalls.sock.closes++;
 }
 
@@ -1027,3 +1044,47 @@
 	return 0;
     return F->defer_check(fd, F->defer_data);
 }
+
+#if USE_ICP_DATA
+/*
+ * Get fake file descriptor suitable for indexing through fd_table.
+ */
+int
+comm_virtual_fd()
+{
+    static int firstfd = -1;
+    struct in_addr nobody;
+    int vfd;
+    int i;
+    
+    if (firstfd == -1){
+	nobody.s_addr = INADDR_ANY;
+	firstfd = comm_open(SOCK_DGRAM, 0, nobody, 0, COMM_NONBLOCKING, "virtual");
+	vfd = firstfd;
+    }
+    else {
+	for (i = 0; i <= Biggest_FD; ++i) {
+	    if (fd_table[i].comm_type == SOCK_VIRTUAL && !fd_table[i].openned)
+		break;
+	} 
+	if (fd_table[i].comm_type != SOCK_VIRTUAL) {
+	    nobody.s_addr = INADDR_ANY;
+	    vfd = comm_open(SOCK_DGRAM, 0, nobody, 0, COMM_NONBLOCKING, "virtual");
+	    debug(5, 4, "comm_virtual_fd: opened new vfd %d (Biggest_FD = %d)\n",
+		   vfd, Biggest_FD);
+	    assert(vfd > -1);
+	}
+	else {
+	    vfd = i;
+	}
+    }
+    
+    fdstat_open(vfd, FD_SOCKET);
+    memset((char *) &fd_table[vfd], '\0', sizeof(FD_ENTRY));
+    fd_table[vfd].openned = 1;
+    fd_table[vfd].lifetime = -1;
+    fd_table[vfd].comm_type = SOCK_VIRTUAL;
+    debug(5, 7, "comm_virtual_fd: returning vfd %d \n", vfd);
+    return(vfd);
+}
+#endif /* USE_ICP_DATA */
Index: squid/src/defines.h
diff -u squid/src/defines.h:1.24 squid/src/defines.h:1.15.2.4
--- squid/src/defines.h:1.24	Thu Aug  8 13:15:19 2002
+++ squid/src/defines.h	Tue Sep  3 10:41:43 2002
@@ -313,6 +313,64 @@
 #define O_BINARY 0
 #endif
 
+/* put.c */
+#define P_ACTIVE(p)  ((p)->flags.connected | (p)->flags.connecting)
+
+#if USE_HINT_CACHE
+/* Hint Cache Interface */
+
+/* Not QUITE compatible with 1.0 due to different tolower treatment
+   of URLs before md5 coding. */
+#define HINT_CACHE_VERSION "2.0"   /* Protocol version */
+
+/* Returns true iff the hint cache is in operation. */
+#define HINT_CACHE_ACTIVE()  (HCDisk != NULL)
+
+#define URLKEY_COMPARE(k1, k2)   ((k1).key - (k2).key)
+
+/* Hint Cache Primitives */
+#define HCE_VALID(hce)      ((hce)->ipaddr.s_addr != INADDR_ANY &&\
+			     URLKEY_COMPARE((hce)->key, INVALID_URL_KEY))
+#define HCE_INVALIDATE(hce) ((hce)->ipaddr.s_addr  = INADDR_ANY, \
+			     (hce)->key = INVALID_URL_KEY);
+
+#define HINT_CACHE_KEY(e) (((URLKey *) ((e)->hchash.key)))
+
+/* Hint protocol event types */
+#define HC_InvalToParent  1
+#define HC_InvalToChild   2
+#define HC_InformToParent 3
+#define HC_InformToChild  4
+#define HC_NewVersion     5
+#define HC_Join           6
+#define HC_Leave          7
+#define HC_Ignore         8 /* Message supressed. Ignore it. */
+#define HC_NotChild       9 /* "I am not your child" */
+#define HC_Error         10
+
+/* Smallest an HCUPDATE can be (e.g., length of a v1 update). */
+#define HCU_MINLEN 24
+
+/* Hint Cache Disk */
+#define HCD_VERSION 2
+
+#define HCD_PREFETCH_THRESH 3
+
+#endif /* USE_HINT_CACHE */
+
+
+/* CygWin & Windows NT Port */
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+#define _WIN_OS_UNKNOWN	0
+#define _WIN_OS_WIN32S	1
+#define _WIN_OS_WIN95	2
+#define _WIN_OS_WIN98	3
+#define _WIN_OS_WINNT	4
+#define _WIN_OS_WIN2K	5
+#define _WIN_OS_WINXP	6
+#endif
+
+#define	HTTP_REQBUF_SZ	4096
 /*
  * Macro to find file access mode
  */
Index: squid/src/dist.c
diff -u /dev/null squid/src/dist.c:1.1.2.5
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/dist.c	Mon May 20 19:46:42 2002
@@ -0,0 +1,217 @@
+/*
+ * $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+ *
+ * Distribution network algorithm.
+ *
+ * AUTHOR: Jon Kay, 1997
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * --------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by
+ *  the National Science Foundation.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  
+ */
+
+#include "squid.h"
+
+static void distUpdate(Updatee *u);
+
+static char urlbuf[MAX_URL + 48];
+
+peer *DistAllPeers = 0;
+
+/* Create new updatee ds & add to object's updatee list */
+Updatee *
+distNewUpdatee(StoreEntry *entry, struct in_addr host, u_short dport)
+{
+    Updatee *u;
+    
+    ++statCounter.dist.dists;
+    /* Don't add a client if it isn't interested in updates */
+    if (dport == 0)
+	return(NULL);
+    
+    /* Make sure new guy isn't already on list */
+    for (u = entry->updatees; u; u = u->next) {
+	if (u->saddr.sin_addr.s_addr == host.s_addr
+	    && u->saddr.sin_port == dport)
+	    return(u);
+    }
+
+    /* Need new updatee, alloc and add to list */
+    u = xcalloc(sizeof(*u), 1);
+    u->next = entry->updatees;
+    u->entry = entry;
+    u->saddr.sin_family = AF_INET;
+    u->saddr.sin_addr = host;
+    u->saddr.sin_port = dport;
+    u->lastmod = entry->lastmod;
+    entry->updatees = u;
+    ++statCounter.dist.updatees;
+    return(u);
+}
+
+void
+distDelUpdatee(StoreEntry *entry, struct in_addr host, int dport)
+{
+    Updatee *i, **optr;
+
+    ++statCounter.dist.undists;
+    optr = &entry->updatees;
+    for (i = entry->updatees; i; i = i->next) {
+	if (i->saddr.sin_addr.s_addr == host.s_addr
+	    && i->saddr.sin_port == dport) {
+	    (*optr) = i->next;
+	    --statCounter.dist.updatees;
+	    xfree(i);
+	}
+	optr = &i->next;
+    }
+}
+
+void
+distDelUpdatees(Updatee *u)
+{
+    Updatee *nu;
+
+    for ( ; u; u = nu) {
+	nu = u->next;
+	--statCounter.dist.updatees;
+	xfree(u);
+    }
+}
+
+void
+distUpdateeChangeEntry(StoreEntry *entry, Updatee *u)
+{
+    entry->updatees = u;
+    for ( ; u; u = u->next) {
+	u->entry = entry;
+    }
+}
+    
+
+/* Code to distribute contents of entry to updatees */
+
+static void
+distUpdate(Updatee *u)
+{
+    if (u->lastmod >= u->entry->lastmod)
+	/* Already has this version */
+	return;
+    u->lastmod = u->entry->lastmod;  /* Mark version being xferred */
+    
+    ++statCounter.dist.updates;
+    kb_incr(&statCounter.dist.update_kbytes, u->entry->mem_obj->inmem_hi);
+
+    u->p = putSend(u->entry, &u->saddr, (PF *) 0, 0, 1 /* dodist */);
+}
+
+/* Distribute entry contents to anybody interested */
+void
+distEntryUpdate(StoreEntry *entry, request_t *req, struct sockaddr_in *src)
+{
+    Updatee *u;
+    
+    ++statCounter.dist.content_upd;
+
+    /* Open distribution socket to everybody interested */
+    for (u = entry->updatees; u; u = u->next) {
+	assert(req);
+	/* Don't send updates to GET-requesting clients,
+	   when we happen to know their identity.  We do
+	   know with other peers and on DIST reqs. */
+	if (req->dist_type == DIST_DIST
+	    && req->dist_port == u->saddr.sin_port
+	    && req->my_addr.s_addr == u->saddr.sin_addr.s_addr)
+	    continue;
+	
+	/* No problems here - send it on out */
+	distUpdate(u);
+    }
+}
+
+
+/* Best-case object consistency support */
+
+/* Change url from http: to httpdist1234: */
+/* Note: returns pointer to static buffer - contents change on next call. */
+char *
+distifyUrl(char *url)
+{
+    char distbuf[48];  /* dist string holder */
+    int plen, poff;
+    char *eop;
+
+    /* Find the end of the protocol field */
+    if ((eop = strchr(url, ':')) == NULL)
+	/* Give up if not of form http://... */
+	return(url);
+    poff = eop - url;
+
+    snprintf(distbuf, sizeof(distbuf), "dist%d",
+	     ntohs(Config.Sockaddr.http->s.sin_port));
+    plen = strlen(distbuf);
+
+    /* Assemble the new URL */
+    xmemcpy(urlbuf, url, poff);
+    xmemcpy(urlbuf + poff, distbuf, plen);
+    xstrncpy(urlbuf + poff + plen, url + poff, MAX_URL);
+    
+    return(urlbuf);
+}
+
+
+/* Report on push stats */
+void
+statDistPrint(StoreEntry * sentry)
+{
+    statPutPrint(sentry);
+    
+    storeAppendPrintf(sentry, "\nDIST Statistics:\n\n");
+    storeAppendPrintf(sentry, "DIST requests: %d\n",
+		      statCounter.dist.dists);
+    storeAppendPrintf(sentry, "unDIST requests: %d\n", 
+		      statCounter.dist.undists);
+    storeAppendPrintf(sentry, "Updates Sent: %d\n", 
+		      statCounter.dist.updates);
+    storeAppendPrintf(sentry, "KBytes of Update Sent: %d\n", 
+		      statCounter.dist.update_kbytes);
+    storeAppendPrintf(sentry, "Content Updates: %d\n", 
+		      statCounter.dist.content_upd);
+    storeAppendPrintf(sentry, "Updatee Structures: %d\n", 
+		      statCounter.dist.updatees);
+    storeAppendPrintf(sentry, "Updatee Memory Consumption: %d\n",
+		      statCounter.dist.updatees * sizeof(Updatee));
+}
+
+
+/* Need this to make sure that reconfiguration gives correctly
+   updated FwdPushLinks */
+void
+distInit()
+{
+    DistAllPeers = 0;
+
+    cachemgrRegister("push", "Push Stats",
+	statDistPrint, 0, 1);
+}
+
+
Index: squid/src/enums.h
diff -u squid/src/enums.h:1.37 squid/src/enums.h:1.27.2.7
--- squid/src/enums.h:1.37	Sun Jul 21 14:48:03 2002
+++ squid/src/enums.h	Tue Sep  3 10:41:45 2002
@@ -48,6 +48,7 @@
     LOG_TCP_MEM_HIT,
     LOG_TCP_DENIED,
     LOG_TCP_OFFLINE_HIT,
+    LOG_TCP_PUT,
 #if LOG_TCP_REDIRECTS
     LOG_TCP_REDIRECT,
 #endif
@@ -56,6 +57,7 @@
     LOG_UDP_DENIED,
     LOG_UDP_INVALID,
     LOG_UDP_MISS_NOFETCH,
+    LOG_UDP_PUT,
     LOG_ICP_QUERY,
     LOG_TYPE_MAX
 } log_type;
@@ -92,6 +94,7 @@
     ERR_FTP_UNAVAILABLE,
     ERR_ONLY_IF_CACHED_MISS,	/* failure to satisfy only-if-cached request */
     ERR_TOO_BIG,
+    ERR_CONFLICT,
     TCP_RESET,
     ERR_MAX
 } err_type;
@@ -437,6 +440,9 @@
     PROTO_WHOIS,
     PROTO_INTERNAL,
     PROTO_HTTPS,
+#if USE_HINT_CACHE
+    PROTO_ROUTE,
+#endif
     PROTO_MAX
 } protocol_t;
 
@@ -705,6 +711,7 @@
     CBDATA_helper_stateful_server,
     CBDATA_HttpStateData,
     CBDATA_peer,
+    CBDATA_Pusher,
     CBDATA_ps_state,
     CBDATA_RemovalPolicy,
     CBDATA_RemovalPolicyWalker,
@@ -723,6 +730,28 @@
     VARY_CANCEL
 };
 
+enum {
+    DIST_NONE,
+    DIST_DIST,
+    DIST_UNDIST
+};
+
+#if USE_HINT_CACHE
+enum HintCacheNet_State {
+    HC_uninitialized,
+    HC_filling,
+    HC_full,
+    HC_destroyed
+};
+
+
+typedef enum HintCacheNeighborActionE {
+    NEIGHBOR_ADD,
+    NEIGHBOR_REMOVE
+} NeighborAction;
+
+#endif /* USE_HINT_CACHE */
+
 /*
  * Store digest state enum
  */
Index: squid/src/globals.h
diff -u squid/src/globals.h:1.17 squid/src/globals.h:1.14.2.4
--- squid/src/globals.h:1.17	Sun Jul 14 17:43:58 2002
+++ squid/src/globals.h	Tue Sep  3 10:41:47 2002
@@ -159,6 +159,19 @@
 extern RemovalPolicy *mem_policy;
 extern hash_table *proxy_auth_username_cache;	/* NULL */
 extern int incoming_sockets_accepted;
+extern peer *DistAllPeers;
+#if USE_HINT_CACHE
+extern hash_table hint_table;
+extern const URLKey INVALID_URL_KEY;
+extern HintCacheDisk *HCDisk;
+extern HintCacheNet *parentOutgoingA;
+extern HintCacheNet *childrenOutgoingA;
+extern HintCacheNet *neighborsOutgoing;
+extern HintCacheDisk *hcDisk;
+#if USE_DYNAMIC_HIERARCHY
+
+#endif /* USE_DYNAMIC_HIERARCHY */
+#endif /* USE_HINT_CACHE */
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
 extern unsigned int WIN32_OS_version;	/* 0 */
 extern char *WIN32_OS_string;	/* NULL */
Index: squid/src/http.c
diff -u squid/src/http.c:1.22 squid/src/http.c:1.17.2.6
--- squid/src/http.c:1.22	Sun Sep  1 09:30:42 2002
+++ squid/src/http.c	Tue Sep  3 10:41:48 2002
@@ -45,9 +45,7 @@
 static CWCB httpSendComplete;
 static CWCB httpSendRequestEntity;
 
-static PF httpReadReply;
 static void httpSendRequest(HttpStateData *);
-static PF httpStateFree;
 static PF httpTimeout;
 static void httpCacheNegatively(StoreEntry *);
 static void httpMakePrivate(StoreEntry *);
@@ -55,7 +53,7 @@
 static int httpCachableReply(HttpStateData *);
 static void httpMaybeRemovePublic(StoreEntry *, http_status);
 
-static void
+void
 httpStateFree(int fd, void *data)
 {
     HttpStateData *httpState = data;
@@ -79,9 +77,11 @@
 int
 httpCachable(method_t method)
 {
-    /* GET and HEAD are cachable. Others are not. */
-    if (method != METHOD_GET && method != METHOD_HEAD)
+    /* GET, PUT, and HEAD are cachable. Others are not. */
+    if (method != METHOD_GET && method != METHOD_HEAD &&
+ 	method != METHOD_PUT) {
 	return 0;
+    }
     /* else cachable */
     return 1;
 }
@@ -414,6 +414,7 @@
 	t = httpState->reply_hdr + k;
     }
     *t = '\0';
+    httpState->body_remain -= hdr_len - (t - httpState->reply_hdr);
     httpState->reply_hdr_state++;
     assert(httpState->reply_hdr_state == 1);
     ctx = ctx_enter(entry->mem_obj->url);
@@ -423,6 +424,9 @@
     /* Parse headers into reply structure */
     /* what happens if we fail to parse here? */
     httpReplyParse(reply, httpState->reply_hdr, hdr_len);
+    if (reply->content_length > 0) {
+        httpState->body_remain = reply->content_length + reply->hdr_sz;
+    }
     storeTimestampsSet(entry);
     /* Check if object is cacheable or not based on reply code */
     debug(11, 3) ("httpProcessReplyHeader: HTTP CODE: %d\n", reply->sline.status);
@@ -531,7 +535,7 @@
 /* This will be called when data is ready to be read from fd.  Read until
  * error or connection closed. */
 /* XXX this function is too long! */
-static void
+void
 httpReadReply(int fd, void *data)
 {
     HttpStateData *httpState = data;
@@ -610,7 +614,7 @@
 	fwdFail(httpState->fwd, err);
 	httpState->eof = 1;
 	comm_close(fd);
-    } else if (len == 0) {
+    } else if (len == 0 || len >= httpState->body_remain) {
 	/* Connection closed; retrieval done. */
 	httpState->eof = 1;
 	if (httpState->reply_hdr_state < 2)
@@ -621,8 +625,26 @@
 	     * we want to process the reply headers.
 	     */
 	    httpProcessReplyHeader(httpState, buf, len);
-	fwdComplete(httpState->fwd);
-	comm_close(fd);
+	else
+	    /* whole body is subtracted */
+	    httpState->body_remain -= len;
+	debug(50, 7) ("httpReadReply: body_remain = %d (len %d, state %d)\n",
+	      httpState->body_remain, len, httpState->reply_hdr_state);
+	if (len > 0) {
+	    storeAppend(entry, buf, len); 
+	    distEntryUpdate(entry, entry->mem_obj->request,
+			    httpState->peer ? &httpState->peer->in_addr : 0);
+	}
+	if (entry->mem_obj->request &&
+	    entry->mem_obj->request->method == METHOD_PUT) {
+	    putReplyAndClose(fd, entry);
+	    debug(50, 8) ("httpReadReply: called putReplyAndClose\n");
+	    /* putReplyAndClose calls storeComplete() */
+	}
+	else {
+	    fwdComplete(httpState->fwd);
+	    comm_close(fd);
+	}
     } else {
 	if (httpState->reply_hdr_state < 2) {
 	    httpProcessReplyHeader(httpState, buf, len);
@@ -639,7 +661,11 @@
 		    EBIT_CLR(entry->flags, ENTRY_FWD_HDR_WAIT);
 	    }
 	}
+	httpState->body_remain -= len;
+	debug(50, 8) ("httpReadReply: %d remain\n", httpState->body_remain);
 	storeAppend(entry, buf, len);
+	distEntryUpdate(entry, entry->mem_obj->request,
+			httpState->peer ? &httpState->peer->in_addr : 0);
 	if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
 	    /*
 	     * the above storeAppend() call could ABORT this entry,
@@ -904,9 +930,16 @@
     http_state_flags flags)
 {
     const int offset = mb->size;
+    const char *url;
+    
+    url = strLen(request->urlpath) ? strBuf(request->urlpath) : "/";
+    if (request->flags.distify) {
+ 	/* Ask other cache for dist */
+ 	url = (const char *) distifyUrl((char *) url);
+    }
+    
     memBufPrintf(mb, "%s %s HTTP/1.0\r\n",
-	RequestMethodStr[request->method],
-	strLen(request->urlpath) ? strBuf(request->urlpath) : "/");
+	RequestMethodStr[request->method], url);
     /* build and pack headers */
     {
 	HttpHeader hdr;
@@ -983,6 +1016,7 @@
     HttpStateData *httpState;
     request_t *proxy_req;
     request_t *orig_req = fwd->request;
+    peer *peer;
     debug(11, 3) ("httpStart: \"%s %s\"\n",
 	RequestMethodStr[orig_req->method],
 	storeUrl(fwd->entry));
@@ -991,13 +1025,15 @@
     httpState->fwd = fwd;
     httpState->entry = fwd->entry;
     httpState->fd = fd;
+    httpState->body_remain = 0x7fffffff;
     if (fwd->servers)
 	httpState->peer = fwd->servers->peer;	/* might be NULL */
-    if (httpState->peer) {
+    peer = httpState->peer;
+    if (peer) {
 	proxy_req = requestCreate(orig_req->method,
 	    PROTO_NONE, storeUrl(httpState->entry));
-	xstrncpy(proxy_req->host, httpState->peer->host, SQUIDHOSTNAMELEN);
-	proxy_req->port = httpState->peer->http_port;
+	xstrncpy(proxy_req->host, peer->host, SQUIDHOSTNAMELEN);
+	proxy_req->port = peer->http_port;
 	proxy_req->flags = orig_req->flags;
 	proxy_req->lastmod = orig_req->lastmod;
 	httpState->request = requestLink(proxy_req);
@@ -1008,8 +1044,12 @@
 	 * We might end up getting the object from somewhere else if,
 	 * for example, the request to this neighbor fails.
 	 */
-	if (httpState->peer->options.proxy_only)
+	if (peer->options.proxy_only)
 	    storeReleaseRequest(httpState->entry);
+	/* Use consistency protocol for this request */
+	if (peer->options.dist) {
+	    httpState->request->flags.distify = 1;
+	}
 #if DELAY_POOLS
 	assert(delayIsNoDelay(fd) == 0);
 	if (httpState->peer->options.no_delay)
@@ -1107,3 +1147,32 @@
     version->major = major;
     version->minor = minor;
 }
+
+/*
+ * Create an httpState parallel to an existing clientHttpRequest
+ * Assumption: http->entry is either zero or locked.
+ */
+HttpStateData *
+httpStateFromClient(clientHttpRequest *http)
+{
+    HttpStateData *httpState;
+
+    /* Make me an httpState */
+    httpState = cbdataAlloc(HttpStateData);
+    
+    /* Fill in the blanks */
+    httpState->entry = http->entry;
+    httpState->request = http->request;
+    httpState->body_remain = 0x7fffffff;
+
+    assert(http->entry->lock_count >= 1);
+    /* Lock entry for a second time to reflect presence in httpState */
+    /* XXX - can't use storeLockObject() because is NOT_IN_MEMORY (!!!) */
+    httpState->entry->lock_count++;
+    assert(http->entry->lock_count >= 2);
+
+    /* Register new request pointer */
+    requestLink(httpState->request);
+
+    return(httpState);
+}
